# Copyright (C) 2008 Libresoft Research Group
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Authors : Israel Herraiz <herraiz@gsyc.escet.urjc.es>

from mydatabase import *
import os
import commands
MAX_DATE = '2006-02-01'

class App:

    def __init__(self):
        self.db = MyDatabase()
        self.db.user = "root"
        self.db.password = ""
        self.db.name = "sf"
        self.db.connect()

    def run(self):

        self.db.getListOfProjects()

        projects = [x[0].lstrip("sf_") for x in self.db.cursor_get.fetchall()]

        for p in projects:
            self.checkout(p)
            sloc = self.measure(p)
            files = self.measure(p,True)
            self.db.updateSize("sf_"+p,sloc,files)

    def checkout(self,p):

        outputdir = '/tmp/cvs/'

        if not os.path.exists(outputdir):
            os.makedirs(outputdir)
        else:
            os.system("cd /tmp/cvs/ && rm -Rdf *")

        cvscmd = " cvs -z3 -d:pserver:anonymous@"+p+".cvs.sourceforge.net:/cvsroot/"+p+" co -P -D '2006-02-01' ."
        os.system("cd /tmp/cvs/ && "+cvscmd)
        
    def measure(self,p,file=False):
        if file:
            cmd = "cd /tmp/cvs/ && sloccount --filecount ."
        else:
            cmd = "cd /tmp/cvs/ && sloccount ."
            
        output = commands.getoutput(cmd)

        sloc = -1

        if file:
            msg = "Total Number of Source Code Files"
        else:
            msg = "Total Physical Source Lines of Code (SLOC)"

        for l in output.split('\n'):
            if msg in l:
                sloc = int(l.split("=")[1].replace(",","").replace(".",""))
                break

        return sloc
                
if __name__ == '__main__':

    app = App()
    app.run()
